\\ Copyright 2016 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  If not, see <http://www.gnu.org/licenses/>.

default(recover,0);
default(strictargs,1);
iferr(read("recurrence-guess.gp"),e,read("../recurrence-guess.gp"));


v = [0, 3/13, 2622/9841, 1016061834009/3812798742493, 59083728426486717204582195369095267004/221713244121518884974124815309574946401];
len=2;
print("m");
m = matrix(len,len,i,j, v[i+j-1])
a = vectorv(len,i, v[i+len])
f = matsolve(m,a);
print("f = ",f);
m*f == a
recurrence_guess_INTERNAL_check(f,v)

to_gf(f,v) =
{
  my(f = recurrence_guess_values_to_factors(v));
  if(f == [], return(0));

  my(f_pol = Pol(f),
     low_pol = Polrev(v[1 .. #f]),
     low_product_mod = (f_pol*low_pol) % ('x)^(#f - 1),
     g = ( x*low_product_mod - low_pol )/(x*f_pol-1));
  g;
}

print("terms");
f[1]*v[1] + f[2]*v[2]
f[1]*v[2] + f[2]*v[3]
f[1]*v[3] + f[2]*v[4]

g=to_gf(f,v)
recurrence_guess_INTERNAL_gf_terms(g,5)

\\recurrence_guess_factors_and_values_to_gf(f,v)
